SystemOrganization addCategory: #'Seaside-Tests-HTML5-Tags'!

WAFunctionalTest subclass: #WACanvasTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-HTML5-Tags'!

!WACanvasTagTest methodsFor: 'private' stamp: 'pmm 3/16/2007 14:00'!
drawFunction
	"http://developer.mozilla.org/samples/canvas-tutorial/2_7_canvas_combined.html"
	^
'function drawShape(){
  // get the canvas element using the DOM
  var canvas = document.getElementById(''tutorial'');

  // Make sure we don''t execute when canvas isn''t supported
  if (canvas.getContext){

    // use getContext to use the canvas for drawing
    var ctx = canvas.getContext(''2d'');

    // Draw shapes
    roundedRect(ctx,12,12,150,150,15);
    roundedRect(ctx,19,19,150,150,9);
    roundedRect(ctx,53,53,49,33,10);
    roundedRect(ctx,53,119,49,16,6);
    roundedRect(ctx,135,53,49,33,10);
    roundedRect(ctx,135,119,25,49,10);

    // Character 1
    ctx.beginPath();
    ctx.arc(37,37,13,Math.PI/7,-Math.PI/7,false);
    ctx.lineTo(34,37);
    ctx.fill();

    // blocks
    for(i=0;i<8;i++){
      ctx.fillRect(51+i*16,35,4,4);
    }
    for(i=0;i<6;i++){
      ctx.fillRect(115,51+i*16,4,4);
    }
    for(i=0;i<8;i++){
      ctx.fillRect(51+i*16,99,4,4);
    }

    // character 2
    ctx.beginPath();
    ctx.moveTo(83,116);
    ctx.lineTo(83,102);
    ctx.bezierCurveTo(83,94,89,88,97,88);
    ctx.bezierCurveTo(105,88,111,94,111,102);
    ctx.lineTo(111,116);
    ctx.lineTo(106.333,111.333);
    ctx.lineTo(101.666,116);
    ctx.lineTo(97,111.333);
    ctx.lineTo(92.333,116);
    ctx.lineTo(87.666,111.333);
    ctx.lineTo(83,116);
    ctx.fill();
    ctx.fillStyle = "white";
    ctx.beginPath();
    ctx.moveTo(91,96);
    ctx.bezierCurveTo(88,96,87,99,87,101);
    ctx.bezierCurveTo(87,103,88,106,91,106);
    ctx.bezierCurveTo(94,106,95,103,95,101);
    ctx.bezierCurveTo(95,99,94,96,91,96);
    ctx.moveTo(103,96);
    ctx.bezierCurveTo(100,96,99,99,99,101);
    ctx.bezierCurveTo(99,103,100,106,103,106);
    ctx.bezierCurveTo(106,106,107,103,107,101);
    ctx.bezierCurveTo(107,99,106,96,103,96);
    ctx.fill();
    ctx.fillStyle = "black";
    ctx.beginPath();
    ctx.arc(101,102,2,0,Math.PI*2,true);
    ctx.fill();
    ctx.beginPath();
    ctx.arc(89,102,2,0,Math.PI*2,true);
    ctx.fill();
  } else {
    alert(''You need Safari or Firefox 1.5+ to see this demo.'');
  }
}

function roundedRect(ctx,x,y,width,height,radius){
  ctx.beginPath();
  ctx.moveTo(x,y+radius);
  ctx.lineTo(x,y+height-radius);
  ctx.quadraticCurveTo(x,y+height,x+radius,y+height);
  ctx.lineTo(x+width-radius,y+height);
  ctx.quadraticCurveTo(x+width,y+height,x+width,y+height-radius);
  ctx.lineTo(x+width,y+radius);
  ctx.quadraticCurveTo(x+width,y,x+width-radius,y);
  ctx.lineTo(x+radius,y);
  ctx.quadraticCurveTo(x,y,x,y+radius);
  ctx.stroke();
}
'! !

!WACanvasTagTest methodsFor: 'accessing' stamp: 'pmm 3/28/2007 10:49'!
label
	^'<canvas>'! !

!WACanvasTagTest methodsFor: 'rendering' stamp: 'pmm 3/16/2007 14:03'!
renderContentOn: html
	html script: self drawFunction.
	html canvas id: 'tutorial'; width: 150; height: 150.
	html script: 'drawShape()'
! !

WAFunctionalTest subclass: #WAHtml5ContentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-HTML5-Tags'!

!WAHtml5ContentTest methodsFor: 'accessing' stamp: 'pmm 8/8/2007 21:52'!
label
	^'Html 5 Content Model'! !

!WAHtml5ContentTest methodsFor: 'rendering' stamp: 'pmm 8/8/2007 21:49'!
renderContentOn: html
	html header: [
		html heading level1;
			with: [
				html anchor
					url: 'http://www.elharo.com/blog';
					with: 'Mokka mit Schlag' ] ].
	html section: [
		html article: [
			html heading level2;
				with: [
					html anchor
						url: '/blog/birding/2007/04/23/spring-comes-and-goes-in-sussex-county/';
						with: 'Spring Comes (and Goes) in Sussex County' ].
				html paragraph: 'Yesterday I joined the Brooklyn Bird Club for our annual trip to Western New Jersey, specifically Hyper Humus, a relatively recently discovered hot spot. It started out as a nice winter morning when we arrived at the site at 7:30 A.M., progressed to Spring around 10:00 A.M., and reached early summer by 10:15.' ].
		html article: [
			html heading level2;
				with: [
					html anchor
						url: '/blog/birding/2007/04/23/but-does-it-count-for-your-life-list/';
						with: 'But does it count for your life list?' ].
			html paragraph: [
				html text: 'Seems you can now go '.
				html anchor
					url: 'http://www.wired.com/science/discoveries/news/ 2007/04/cone_sf';
					with: 'bird watching via the Internet'.
				html text: '. I haven''t been able to test it out yet (20 user limit apparently) but this is certainly cool. Personally, I can''t imagine it replacing actually being out in the field by any small amount. On the other hand, I''ve always found it quite sad to meet senior birders who are no longer able to hold binoculars steady or get to the park. I can imagine this might be of some interest to them. At least one elderly birder did a big year on TV, after he could no longer get out so much. This certainly tops that.' ] ] ].
	
	html navigation: [
		html anchor
			url: '/blog/page/2/';
			with: '<< Previous Entries' ].
		
	html navigation: [
		html unorderedList: [
			html listItem: [
				html heading level2;
					with: 'Info'.
				html unorderedList: [
					html listItem: [
						html anchor
							url: '/blog/comment-policy/';
							with: 'Comment Policy' ].
					html listItem: [
						html anchor
							url: '/blog/todo-list/';
							with: 'Todo List' ] ] ].
			html listItem: [
				html heading level2;
					with: 'Archives'.
				html unorderedList: [
					html listItem: [
						html anchor
							url: '/blog/2007/04/';
							with: 'April 2007' ].
					html listItem: [
						html anchor
							url: '/blog/2007/02/';
							with: 'February 2007' ] ] ].
					html listItem: [
						html anchor
							url: '/blog/2007/01/';
							with: 'January 2007' ] ] ].
				
	html aside: [
		html heading level3
			with: '.xf-value'.
		html paragraph: [
			html text: 'The '.
			html code: '.xf-value'.
			html text: ' selector used here styles the input field value but not its label. This is actually inconsistent with the current CSS3 draft. The example really should use the '.
			html code: '::value'.
			html text: 'pseudo-class instead like so:' ].
		html preformatted: 
'input::value { width: 20em; }
#ccnumber::value { width: 18em }
#zip::value { width: 12em }
#state::value { width: 3em  }'. 
		html paragraph: 'However, Firefox doesn''t yet support this syntax' ].
				
	html footer: [
		html paragraph: 'Copyright 2007 Elliotte Rusty Harold' ]! !

WAFunctionalTest subclass: #WAHtml5ElementsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-HTML5-Tags'!

!WAHtml5ElementsTest methodsFor: 'accessing' stamp: 'pmm 3/28/2007 22:11'!
label
	^'Html 5 Elements'! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 8/8/2007 22:07'!
renderContentOn: html
	self renderFigureOn: html.
	self renderMarkedOn: html.
	self renderMeterOn: html.
	self renderProgressOn: html.
	self renderDialogOn: html.
	self renderTimeOn: html.
	self renderDetailsOn: html.
	self renderDatagridOn: html.
	self renderMenuOn: html! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 8/8/2007 21:57'!
renderDatagridOn: html
	html heading level2; with: '<datagrid>'.

	html datagrid: [
		html table: [
			html tableRow: [
				html tableData: 'Jones'.
				html tableData: 'Allison'.
				html tableData: 'A-'.
				html tableData: 'B+'.
				html tableData: 'A' ].
			html tableRow: [
				html tableData: 'Smith'.
				html tableData: 'Johnny'.
				html tableData: 'A'.
				html tableData: 'C+'.
				html tableData: 'A' ].
			html tableRow: [
				html tableData: 'Willis'.
				html tableData: 'Sydney'.
				html tableData: 'C-'.
				html tableData: 'D'.
				html tableData: 'F' ].
			html tableRow: [
				html tableData: 'Wilson'.
				html tableData: 'Frank'.
				html tableData: 'B-'.
				html tableData: 'B+'.
				html tableData: 'A' ]  ] ]! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 8/8/2007 21:51'!
renderDetailsOn: html
	html heading level2; with: '<details>'.
	
	html details: [
		html legend: '[Sibley, 2000]'.
		html paragraph: 'Sibley, David Allen, The Sibley Guide to Birds, 
(New York: Chanticleer Press, 2000) p. 247' ]! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 3/28/2007 22:49'!
renderDialogOn: html
	html heading level2; with: '<dialog>'.
	
	html dialog: [
		html definitionTerm: 'Costello'.
		html definitionData: 'Look, you gotta first baseman?'.
		html definitionTerm: 'Abbott'.
		html definitionData: 'Certainly.'.
		html definitionTerm: 'Costello'.
		html definitionData: 'Who''s playing first?'.
		html definitionTerm: 'Abbott'.
		html definitionData: 'That''s right.'.
		html definitionTerm: 'Costello'.
		html definitionData: 'When you pay off the first baseman every month, who gets the money?'.
		html definitionTerm: 'Abbott'.
		html definitionData: 'Every dollar of it'. ]! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'MAD 8/30/2008 11:17'!
renderFigureOn: html
	html heading level2; with: '<figure>'.
	html figure: [
		html legend: 'The Profiler Icon'.
		html space.
		html image url: WATestingFiles / #profilerPng; altText: 'profiler' ]! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'mb 10/8/2007 13:53'!
renderHeaderOn: html
	html heading level2; with: '<header>'.
	
	html header: [
		html paragraph: 'Welcome to...'.
		html heading level1; with: 'Voidwars!!' ]! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 3/28/2007 22:15'!
renderMarkedOn: html
	html heading level2; with: '<m> (kitten)'.
	
	html paragraph: [
		html text: 'I also have some '.
		html marked: 'kitten'.
		html text: 's who are visiting me these days. They''re really cute. I think they like my garden!!' ]! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 8/8/2007 22:08'!
renderMenuOn: html
	html heading level2; with: '<menu>'.

	html menu: [
		html command label: 'Do 1st Command'.
		html command label: 'Do 2nd Command'.
		html command label: 'Do 3rd Command' ]! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 3/28/2007 22:43'!
renderMeterOn: html
	html heading level2; with: '<meter>'.
	
	html meter: '75%'.
	html break.
	html meter: '3/4'.
	html break.
	html meter: '6 blocks used (out of 8 total)'.
	html break.
	html meter: 'max: 100; current: 75'.
	html break.
	html meter
		min: 0;
		max: 100;
		value: 75.! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 3/28/2007 22:43'!
renderProgressOn: html
	html heading level2; with: '<progress>'.
	
	html progress: '75%'! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 4/20/2007 01:29'!
renderTimeOn: html
	html heading level2; with: '<time>'.
	
	html paragraph: [
		html text: 'Our first date was '.
		html time
			datetime: '2006-09-23';
			with: 'a saturday'.
		html text: '.' ].
	
	html paragraph: [
		html text: 'We stopped talking at '.
		html time
			datetime: '2006-09-24 05:00 -7';
			with: '5am the next morning'.
		html text: '.' ].
	
	html paragraph: [
		html text: 'Many people get up at '.
		html time: '08:00'.
		html text: '.' ]! !

WAFunctionalTest subclass: #WAHtml5InputTest
	instanceVariableNames: 'search range email url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-HTML5-Tags'!

!WAHtml5InputTest methodsFor: 'accessing' stamp: 'pmm 11/14/2008 17:28'!
email
	^ email! !

!WAHtml5InputTest methodsFor: 'accessing' stamp: 'pmm 11/14/2008 17:28'!
email: anObject
	email := anObject! !

!WAHtml5InputTest methodsFor: 'accessing' stamp: 'pmm 3/28/2007 22:11'!
label
	^'Html 5 Input'! !

!WAHtml5InputTest methodsFor: 'accessing' stamp: 'pmm 11/14/2008 17:27'!
range
	^ range! !

!WAHtml5InputTest methodsFor: 'accessing' stamp: 'pmm 11/14/2008 17:27'!
range: anObject
	range := anObject! !

!WAHtml5InputTest methodsFor: 'rendering' stamp: 'pmm 11/14/2008 17:31'!
renderContentOn: html
	html form: [
		html table: [
			html tableRow: [
				html tableHeading: [ html label: 'required' ].
				html tableData: [ html textInput required ] ].
			html tableRow: [
				html tableHeading: [ html label: 'autofocus' ].
				html tableData: [ html textInput autofocus ] ].
			html tableRow: [
				html tableHeading: [ html label: 'pattern ([0-9][A-Z]{3})' ].
				html tableData: [ html textInput pattern: '[0-9][A-Z]{3}' ] ].
			html tableRow: [
				html tableHeading: [ html label: 'search' ].
				html tableData: [ html searchInput
					autosave: 'Seaside';
					placeholder: 'placeholder ...';
					results: 5;
					incremental: false;
					on: #search of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'range (6..12) by 2' ].
				html tableData: [ html rangeInput
					min: 6;
					max: 12;
					step: 2;
					on: #range of: self.
				html space.
				html render: self range ] ].
			html tableRow: [
				html tableHeading: [ html label: 'email' ].
				html tableData: [ html emailInput on: #email of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'url' ].
				html tableData: [ html urlInput on: #url of: self ] ].
			html tableRow: [
				html tableHeading: [ html label: 'number' ].
				html tableData: [ html numberInput ] ].
			html tableRow: [
				html tableHeading: [ html label: 'datetimelocal' ].
				html tableData: [ html dateTimeLocalInput ] ].
			html tableRow: [
				html tableHeading: [ html label: 'datetime' ].
				html tableData: [ html dateTimeInput ] ].
			html tableRow: [
				html tableHeading: [ html label: 'date' ].
				html tableData: [ html dateInput5 ] ].
			html tableRow: [
				html tableHeading: [ html label: 'time' ].
				html tableData: [ html timeInput5 ] ].
			html tableRow: [
				html tableHeading: [ html label: 'month' ].
				html tableData: [ html monthInput step: 3 ] ].
			html tableRow: [
				html tableHeading: [ html label: 'week' ].
				html tableData: [ html weekInput ] ].
			html tableRow: [
				html tableHeading: [ html label: 'datalist' ].
				html tableData: [ 
					html datalist: [
						html option: 'HTML'.
						html option disabled: true; with: 'XHTML' ] ] ] ].
		html submitButton ]! !

!WAHtml5InputTest methodsFor: 'accessing' stamp: 'pmm 11/14/2008 17:30'!
search
	^ search! !

!WAHtml5InputTest methodsFor: 'accessing' stamp: 'pmm 11/14/2008 17:30'!
search: anObject
	search := anObject! !

!WAHtml5InputTest methodsFor: 'accessing' stamp: 'pmm 11/14/2008 17:28'!
url
	^ url! !

!WAHtml5InputTest methodsFor: 'accessing' stamp: 'pmm 11/14/2008 17:28'!
url: anObject
	url := anObject! !

WAFunctionalTest subclass: #WAVideoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-HTML5-Tags'!

!WAVideoTest methodsFor: 'accessing' stamp: 'pmm 4/4/2007 03:19'!
label
	^'<video>'! !

!WAVideoTest methodsFor: 'rendering' stamp: 'pmm 4/4/2007 03:21'!
renderContentOn: html
	html video 
		url: 'http://people.opera.com/howcome/2007/video/A_New_Computer--small.ogg';
		with: 'Theora decoder not found'! !

!WAPackage class methodsFor: '*seaside-tests-html5' stamp: 'jok 11/13/2008 14:28'!
seasideTestsHTML5
	^ self new
		name: 'Seaside-Tests-HTML5';
		description: 'Unit tests for the package Seaside-HTML5.';
		addDependency: 'Seaside-HTML5';
		addDependency: 'Seaside-Tests-Functional';
		yourself! !
